<?php

namespace Chippyash\Test\Validation\Common;

use Chippyash\Validation\Common\Enum;
use Chippyash\Validation\Messenger;
/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2013-11-19 at 09:44:55.
 */
class EnumTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @dataProvider enums
     */
    public function testWillReturnCorrectResponseForTestDataSetViaMagicInvokeMethod($test, $enum, $result)
    {
        $sut = new Enum($enum);
        $messenger = new Messenger();
        $this->assertEquals($result, $sut($test, $messenger));
        if (!$result) {
            $this->assertEquals('Value is not a valid enumeration', $messenger->implode());
        }
    }

    /**
     * @dataProvider enums
     */
    public function testWillReturnCorrectResponseForTestDataSetViaIsValidMethod($test, $enum, $result)
    {
        $sut = new Enum($enum);
        $this->assertEquals($result, $sut->isValid($test));
        if (!$result) {
            $this->assertEquals(
                'Value is not a valid enumeration',
                implode($sut->getMessages()));
        }
    }

    public function enums()
    {
        return array(
            array('foo', array('foo','bar'), true),
            array('baz', array('foo','bar'), false),
            array('', array('foo','bar'), false),
            array(null, array('foo','bar'), false),
            array(null, array(), false),
            array('foo', array(), false),
        );
    }

}
